/****************************************************************
Project : PPE Robot Solaire
Version : 1
// --------------------------------------------------------------
Fichier source : MainTXWI2V2.c
Date de  cration : 05/07/2009
Mise  jour le : 14/11/2010
// --------------------------------------------------------------
Author  : Philippe Mariano
Company : Lyce Pierre Emile Martin 18000 BOURGES
// --------------------------------------------------------------
Comments: Mise en oeuvre du protocole I2C sur l'interface TWI
(Adaptation de la note d'application AVR315 d'ATMEL)
Transfert de l'tat des BP sur les LEDs de la carte (PCF8574)
// --------------------------------------------------------------
Cross compilateur: CVAVR 2.04.5b
// --------------------------------------------------------------
Chip type           : ATmega8535
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 512
****************************************************************/

#include <mega8535.h>
// =============================================================================================================================
// Bibliothques  rajouter
// -----------------------------------------------------------------------------------------------------------------------------
#include <delay.h>
#include "DriverTWICV2.h"    // Fonctions du drivers TWI adaptes pour CVAVR

// ----------------------------------------------------------------------------------------------------------
// Boucle principale
// ----------------------------------------------------------------------------------------------------------
void main(void)
{
// -----------------------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------------------------
// 1) Messages prdfinis pour les ports I2C PCF8574 associs aux BP et aux LEDs de la carte S_ISI
// -----------------------------------------------------------------------------------------------------------------------------
// Type             Nom                                                     Description
// -----------------------------------------------------------------------------------------------------------------------------
char Frame_I2C_LED_Switching[]={0x40,0x00};           // Trame de commande des LED {addLed + W (0x40), data = Led on=0}
char Frame_I2C_LED_All_Off[]={0x40,0xff};             // Trame d'extinction des LED {addLed + W (ox40), data = all Led off}
char Frame_I2C_BP_Read[]={0x43,0x00};                 // Trame de lecture des BP {addBP + R (0x43), data=nothing}
// =============================================================================================================================

// =============================================================================================================================
// Initialisation
// -----------------------------------------------------------------------------------------------------------------------------
TWI_Master_Initialise(); 	                          // Initialisation de l'interface TWI en mode Standby
// -----------------------------------------------------------------------------------------------------------------------------
// Global enable interrupts
#asm("sei")
// -----------------------------------------------------------------------------------------------------------------------------
// Extinction des LEDs de la carte S_ISI
TWI_Start_Transc_With_Data(Frame_I2C_LED_All_Off,sizeof(Frame_I2C_LED_All_Off));
// -----------------------------------------------------------------------------------------------------------------------------

while (1)
      {
// -----------------------------------------  Champ Lecture des donnes ---------------------------------------------------------
// Lecture de l'tat des BP
        TWI_Start_Transc_With_Data(Frame_I2C_BP_Read,1);      	// Envoi de l'octet d'adresse des BP + bit RW=lecture(0x43)
        TWI_Get_Data_From_Transceiver(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read));// TWI_Get_Data_From_Transceiver(Donnee_BP,2);
// -----------------------------------------  Champ Traitement ------------------------------------------------------------------
        Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1];
// -----------------------------------------  Champ Ecriture des rsultats  -----------------------------------------------------
// Ecriture sur les LED
        TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,sizeof(Frame_I2C_LED_Switching));  // Les LED affichent l'tat des BP
        delay_ms(200);					// Lecture des BP toutes les 200ms
      };
}
// =============================================================================================================================
// *****************************************************************************************************************************



