
;CodeVisionAVR C Compiler V2.04.5b Standard
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8535
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Speed
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 160 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : No
;'char' is unsigned       : Yes
;8 bit enums              : No
;global 'const' stored in FLASH: Yes
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8535
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 512
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _Texte_Accueil_Ligne1=R4
	.DEF _Texte_Accueil_Ligne2=R6
	.DEF _TexteMenuLedBp=R8
	.DEF _TexteMenuMD23=R10
	.DEF _TexteMenuSD21=R12

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _twi_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_tbl10_G101:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G101:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x3:
	.DB  LOW(_0x0*2+85),HIGH(_0x0*2+85)
_0x4:
	.DB  LOW(_0x0*2+102),HIGH(_0x0*2+102)
_0x5:
	.DB  LOW(_0x0*2+119),HIGH(_0x0*2+119)
_0x6:
	.DB  LOW(_0x0*2+136),HIGH(_0x0*2+136)
_0x7:
	.DB  LOW(_0x0*2+153),HIGH(_0x0*2+153)
_0x8:
	.DB  LOW(_0x0*2+170),HIGH(_0x0*2+170)
_0x9:
	.DB  LOW(_0x0*2+187),HIGH(_0x0*2+187)
_0xA:
	.DB  LOW(_0x0*2+204),HIGH(_0x0*2+204)
_0xB:
	.DB  LOW(_0x0*2+221),HIGH(_0x0*2+221)
_0xC:
	.DB  LOW(_0x0*2+238),HIGH(_0x0*2+238)
_0xD:
	.DB  LOW(_0x0*2+255),HIGH(_0x0*2+255)
_0xE:
	.DB  LOW(_0x0*2+272),HIGH(_0x0*2+272)
_0xF:
	.DB  LOW(_0x0*2+289),HIGH(_0x0*2+289)
_0x10:
	.DB  LOW(_0x0*2+306),HIGH(_0x0*2+306)
_0x11:
	.DB  LOW(_0x0*2+323),HIGH(_0x0*2+323)
_0x12:
	.DB  0x1
_0x13:
	.DB  0xB1,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1
	.DB  0x80,0x80,0x80,0x80,0x1,0x5,0x1,0x0
	.DB  0xB0,0x0,0xB0,0x10,0x32,0xB0,0x1,0x80
	.DB  0xB0,0x0,0x80,0xB0,0xF,0x0,0xB0,0x10
	.DB  0x20,0x76,0x40,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x43,0x0,0x40,0x0
	.DB  0x40,0xFF
_0xE7:
	.DB  LOW(_0x0*2),HIGH(_0x0*2),LOW(_0x0*2+17),HIGH(_0x0*2+17),LOW(_0x0*2+34),HIGH(_0x0*2+34),LOW(_0x0*2+51),HIGH(_0x0*2+51)
	.DB  LOW(_0x0*2+68),HIGH(_0x0*2+68)
_0x0:
	.DB  0x20,0x20,0x20,0x54,0x65,0x73,0x74,0x20
	.DB  0x53,0x49,0x53,0x49,0x20,0x20,0x20,0x20
	.DB  0x0,0x20,0x20,0x20,0x20,0x20,0x5B,0x54
	.DB  0x57,0x49,0x5D,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x0,0x31,0x20,0x54,0x65,0x73,0x74
	.DB  0x20,0x42,0x50,0x2D,0x3E,0x4C,0x65,0x64
	.DB  0x20,0x20,0x0,0x32,0x20,0x54,0x65,0x73
	.DB  0x74,0x20,0x4D,0x44,0x32,0x33,0x20,0x20
	.DB  0x20,0x20,0x20,0x0,0x33,0x20,0x54,0x65
	.DB  0x73,0x74,0x20,0x53,0x44,0x32,0x31,0x20
	.DB  0x20,0x20,0x20,0x20,0x0,0x32,0x31,0x20
	.DB  0x43,0x68,0x6F,0x69,0x78,0x20,0x4D,0x6F
	.DB  0x64,0x65,0x73,0x20,0x20,0x0,0x32,0x32
	.DB  0x20,0x41,0x66,0x66,0x20,0x49,0x6E,0x66
	.DB  0x6F,0x73,0x20,0x20,0x20,0x20,0x0,0x52
	.DB  0x65,0x63,0x6F,0x70,0x69,0x65,0x20,0x42
	.DB  0x70,0x2D,0x3E,0x4C,0x65,0x64,0x20,0x0
	.DB  0x5B,0x2B,0x2F,0x2D,0x5D,0x20,0x20,0x20
	.DB  0x5B,0x45,0x63,0x68,0x61,0x70,0x5D,0x20
	.DB  0x0,0x5B,0x45,0x6E,0x74,0x72,0x5D,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x0,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x5B,0x45,0x63,0x68,0x61,0x70
	.DB  0x5D,0x20,0x0,0x5B,0x45,0x6E,0x74,0x72
	.DB  0x5D,0x20,0x20,0x5B,0x45,0x63,0x68,0x61
	.DB  0x70,0x5D,0x20,0x0,0x2B,0x20,0x2D,0x3E
	.DB  0x20,0x44,0x30,0x20,0x5B,0x45,0x63,0x68
	.DB  0x61,0x70,0x5D,0x20,0x0,0x46,0x48,0x2D
	.DB  0x3E,0x20,0x44,0x31,0x20,0x5B,0x45,0x63
	.DB  0x68,0x61,0x70,0x5D,0x20,0x0,0x46,0x42
	.DB  0x2D,0x3E,0x20,0x44,0x32,0x20,0x5B,0x45
	.DB  0x63,0x68,0x61,0x70,0x5D,0x20,0x0,0x2D
	.DB  0x20,0x2D,0x3E,0x20,0x44,0x33,0x20,0x5B
	.DB  0x45,0x63,0x68,0x61,0x70,0x5D,0x20,0x0
	.DB  0x53,0x45,0x54,0x2D,0x3E,0x44,0x34,0x20
	.DB  0x5B,0x45,0x63,0x68,0x61,0x70,0x5D,0x20
	.DB  0x0,0x4F,0x6B,0x2D,0x3E,0x20,0x44,0x35
	.DB  0x20,0x5B,0x45,0x63,0x68,0x61,0x70,0x5D
	.DB  0x20,0x0,0x45,0x4E,0x54,0x2D,0x3E,0x44
	.DB  0x36,0x20,0x5B,0x45,0x63,0x68,0x61,0x70
	.DB  0x5D,0x20,0x0,0x45,0x43,0x48,0x2D,0x3E
	.DB  0x44,0x37,0x20,0x5B,0x45,0x63,0x68,0x61
	.DB  0x70,0x5D,0x20,0x0,0x43,0x68,0x6F,0x69
	.DB  0x78,0x3A,0x20,0x4D,0x6F,0x64,0x65,0x25
	.DB  0x2D,0x75,0x20,0x20,0x20,0x20,0x0,0x31
	.DB  0x2E,0x25,0x2D,0x75,0x20,0x4D,0x6F,0x64
	.DB  0x65,0x25,0x2D,0x75,0x20,0x28,0x2B,0x25
	.DB  0x2D,0x75,0x29,0x20,0x20,0x0,0x53,0x4D
	.DB  0x31,0x3D,0x25,0x2D,0x75,0x20,0x53,0x4D
	.DB  0x32,0x3D,0x25,0x2D,0x75,0x0,0x32,0x2E
	.DB  0x32,0x2E,0x31,0x20,0x52,0x65,0x67,0x25
	.DB  0x2D,0x75,0x3D,0x20,0x25,0x2D,0x75,0x0
	.DB  0x32,0x2E,0x32,0x2E,0x32,0x20,0x56,0x65
	.DB  0x72,0x73,0x69,0x6F,0x6E,0x3D,0x25,0x2D
	.DB  0x75,0x0,0x32,0x2E,0x32,0x2E,0x33,0x20
	.DB  0x55,0x62,0x61,0x74,0x74,0x3D,0x25,0x2D
	.DB  0x75,0x2E,0x25,0x2D,0x75,0x56,0x0
_0x200005F:
	.DB  0x1
_0x2000000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0
_0x2080003:
	.DB  0xF8
_0x20A0003:
	.DB  0x76,0x0,0x34,0xD,0x6,0x35,0x4,0x10
	.DB  0x42,0x9F,0x34,0x83,0x2
_0x20A0013:
	.DB  0x76,0x40,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0
	.DB  0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0
	.DB  0xA0,0xA0,0x0
_0x20C0003:
	.DB  0x1

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x02
	.DW  _Ligne0MenuMode
	.DW  _0x3*2

	.DW  0x02
	.DW  _Ligne0MenuInfos
	.DW  _0x4*2

	.DW  0x02
	.DW  _TexteTest1BpsurLed
	.DW  _0x5*2

	.DW  0x02
	.DW  _Ligne1PlusMoins
	.DW  _0x6*2

	.DW  0x02
	.DW  _Ligne1ChoixEntr
	.DW  _0x7*2

	.DW  0x02
	.DW  _Ligne1ChoixEchap
	.DW  _0x8*2

	.DW  0x02
	.DW  _Ligne1ChoixEchapOk
	.DW  _0x9*2

	.DW  0x02
	.DW  _BpPlusSurD0
	.DW  _0xA*2

	.DW  0x02
	.DW  _BpFlecheHSurD1
	.DW  _0xB*2

	.DW  0x02
	.DW  _BpFlecheHSurD2
	.DW  _0xC*2

	.DW  0x02
	.DW  _BpMoinsSurD3
	.DW  _0xD*2

	.DW  0x02
	.DW  _BpSetSurD4
	.DW  _0xE*2

	.DW  0x02
	.DW  _BpOkSurD5
	.DW  _0xF*2

	.DW  0x02
	.DW  _BpEntrSurD6
	.DW  _0x10*2

	.DW  0x02
	.DW  _BpEchSurD7
	.DW  _0x11*2

	.DW  0x01
	.DW  _Menu_1
	.DW  _0x12*2

	.DW  0x0A
	.DW  0x04
	.DW  _0xE7*2

	.DW  0x01
	.DW  __seed_G100
	.DW  _0x200005F*2

	.DW  0x01
	.DW  _TWI_state_G104
	.DW  _0x2080003*2

	.DW  0x01
	.DW  _Etat_BP_I2C_S1060000000
	.DW  _0x20C0003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x100)
	LDI  R29,HIGH(0x100)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x100

	.CSEG
;/********************************************************************
;This program was produced by the
;CodeWizardAVR V1.24.0 Standard
;Automatic Program Generator
; Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro
;
;Project : PPE Robot solaire
;Version : 1.0.0
;Date    : 06/01/2010
;Mise  jour: 10/11/2010
;Author  : Philippe Mariano
;Company : Lyce Pierre Emile Martin 18000 BOURGES
;Comments: Test de la carte SISI
;Mise en oeuvre du protocole I2C par l'interface TWI
;- Commande d'un afficheur LCD Batron I2C (PCF2119x)
;- Lecture des BP et recopie sur les LED.
;- Test de la carte MD23(Reglage et commande des moteurs en
;Mode0, lecture et affichage des registres)
;- Test de la carte SD21
;
;File : TestSisiV1.c
;Target:  Robot S_ISI
;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;External SRAM size  : 0
;Data Stack size     : 128
;*********************************************************************/
;
;// =============================================================================================================================
;// Partie dclarative du programme
;// =============================================================================================================================
;// Bibliothques et dfinitions
;// =============================================================================================================================
;#include <mega8535.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;// -----------------------------------------------------------------------------------------------------------------------------
;// Bibliothque  rajouter manuellement
;// -----------------------------------------------------------------------------------------------------------------------------
;#include <stdlib.h>
;#include <stdio.h>				// Fonction sprintf
;#include <math.h>
;#include <string.h>				// Fonctions de traitement des chanes de caractres
;#include <delay.h>				// Fonction temporisation
;#include "DriverTWICV2.h"       // Fonctions du drivers TWI adaptes pour CVAVR
;                                // ATTENTION: Vrifier que la taille du buffer est adapte au message (20 par dfaut)
;// -----------------------------------------------------------------------------------------------------------------------------
;// Bibliothque dveloppes pour la carte SISI
;// -----------------------------------------------------------------------------------------------------------------------------
;#include "MD23.h"				// Dfinitions des registres de la carte moteur MD23
;#include "LCDBATRON.h"          // Fonctions de lecture/criture des priphriques I2C
;#include "SISISOL.h"            // Gestion de l'IHM SISI  (
;// -----------------------------------------------------------------------------------------------------------------------------
;// Dclarations divers
;#define	Moteur1			0
;#define	Moteur2			1
;// =============================================================================================================================
;
;// =============================================================================================================================
;// =============================================================================================================================
;// Constantes en flash
;// -----------------------------------------------------------------------------------------------------------------------------
;// Structure pour l'affichage du nom des registres  (A terminer)
;//flash char Table_Name_Register_MD23[3][7]={"Speed1", "Speed2","Enc1a "};   // changer par une structure
;// -----------------------------------------------------------------------------------------------------------------------------
;// Messages textuels prdfinis
;// ATTENTION: imprativement 16 caractres
;// -----------------------------------------------------------------------------------------------------------------------------
;flash char *Texte_Accueil_Ligne1 	= "   Test SISI    ";
;flash char *Texte_Accueil_Ligne2 	= "     [TWI]      ";
;flash char *TexteMenuLedBp			= "1 Test BP->Led  ";
;flash char *TexteMenuMD23			= "2 Test MD23     ";
;flash char *TexteMenuSD21			= "3 Test SD21     ";
;flash char *Ligne0MenuMode			= "21 Choix Modes  ";

	.DSEG
;flash char *Ligne0MenuInfos			= "22 Aff Infos    ";
;flash char *TexteTest1BpsurLed	    = "Recopie Bp->Led ";
;flash char *Ligne1PlusMoins			= "[+/-]   [Echap] ";
;flash char *Ligne1ChoixEntr			= "[Entr]          ";
;flash char *Ligne1ChoixEchap		= "        [Echap] ";
;flash char *Ligne1ChoixEchapOk		= "[Entr]  [Echap] ";
;flash char *BpPlusSurD0				= "+ -> D0 [Echap] ";
;flash char *BpFlecheHSurD1			= "FH-> D1 [Echap] ";
;flash char *BpFlecheHSurD2			= "FB-> D2 [Echap] ";
;flash char *BpMoinsSurD3			= "- -> D3 [Echap] ";
;flash char *BpSetSurD4				= "SET->D4 [Echap] ";
;flash char *BpOkSurD5				= "Ok-> D5 [Echap] ";
;flash char *BpEntrSurD6				= "ENT->D6 [Echap] ";
;flash char *BpEchSurD7				= "ECH->D7 [Echap] ";
;
;// =============================================================================================================================
;
;// =============================================================================================================================
;// =============================================================================================================================
;// Prototypes des fonctions en cours de test
;// -----------------------------------------------------------------------------------------------------------------------------
;// =============================================================================================================================
;
;// =============================================================================================================================
;// =============================================================================================================================
;// ---------------------------------------------- Declare your global variables here -------------------------------------------
;// -----------------------------------------------------------------------------------------------------------------------------
;// Type				Nom														Description
;// -----------------------------------------------------------------------------------------------------------------------------
;// Etats du graphe des transitions "Menus"
;// -----------------------------------------------------------------------------------------------------------------------------
;enum TMenu {Menu1_LED_BP, Menu2_MD23, Menu3_SD21, Copie_BP_Sur_Led, Menu21_Mode_MD23, Menu22_Infos_MD23, Choix_Mode_MD23,
;Reglage_Valeurs_Mode0_MD23, Reglage_Mode1_MD23, Reglage_Mode2_MD23,Reglage_Mode3_MD23, Controle_Moteurs, Info_TensionBatt,
;Info_Version, Info_All} Menu=Menu1_LED_BP, Menu_1=Menu2_MD23;
;// -----------------------------------------------------------------------------------------------------------------------------
;bit Choix_Moteur=0;			// Permet de permuter le rglage de la vitesse des moteurs dans le menu mode 0
;// =============================================================================================================================
;
;
;// =============================================================================================================================
;// =============================================================================================================================
;// Partie excutive du programme
;// =============================================================================================================================
;// =============================================================================================================================
;void main(void)
; 0000 007A {

	.CSEG
_main:
; 0000 007B // =============================================================================================================================
; 0000 007C // ---------------------------------------------- Declare your local variables here --------------------------------------------
; 0000 007D // =============================================================================================================================
; 0000 007E // Messages pour les composants I2C
; 0000 007F // =============================================================================================================================
; 0000 0080 // 1) Messages prdfinis pour les ports I2C PCF8574 associs aux BP et aux LEDs de la carte S_ISI
; 0000 0081 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 0082 // Type 	   		Nom 				       						Description
; 0000 0083 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 0084 char Frame_I2C_LED_All_Off[]={Add_LED_I2C_W,0xff}; 		// Trame d'extinction des LED {SLA+W=0x40, Data = all Led off}
; 0000 0085 char Frame_I2C_LED_Switching[]={Add_LED_I2C_W,0x00}; 	// Trame de commande des LED {SLA+W=0x40, Data : Led_On=0
; 0000 0086 																// or Off=1}. Initialisation = All On.
; 0000 0087 char Frame_I2C_BP_Read[]={Add_BP_I2C_R,0x00}; 			// Trame de lecture des BP {SLA+R=0x43, Data=Nul}
; 0000 0088 // =============================================================================================================================
; 0000 0089 // 2) Messages pour le LCD I2C BATRON de la carte S_ISI
; 0000 008A // -----------------------------------------------------------------------------------------------------------------------------
; 0000 008B // Type 	   		Nom 				       						Description
; 0000 008C // -----------------------------------------------------------------------------------------------------------------------------
; 0000 008D //unsigned char Frame_I2C_LCD_BATRON_Clear[]={0x76,0x00,0x01}; 	// Effacement de l'cran {SLA+W=0x76, acces=RegIR, cde=clear}
; 0000 008E char Frame_I2C_Lcd_Line[19]={0x76,0x40};      	    	// Trame de texte compose de: {SLA+W=0x76, cde=write to DDRAM ,
; 0000 008F 						 	     								// le texte  afficher = 16 caractres max,  Nul }
; 0000 0090                                                             	// Cette trame est remplie avec le tableau String_to_LCD
; 0000 0091 // =============================================================================================================================
; 0000 0092 // 3) Liste de messages prdfinis pour la carte MD23
; 0000 0093 // =============================================================================================================================
; 0000 0094 // 30) Initialisation
; 0000 0095 unsigned char Reset_MD23[]={MD23_ADD_BASE_W,Reg_Commande, Reset_Encodeur};
; 0000 0096 
; 0000 0097 // 31) Mode
; 0000 0098 unsigned char Mode0_MD23[]={MD23_ADD_BASE_W,Reg_Mode,Mode0};
; 0000 0099 
; 0000 009A // 32) Vitesse des moteurs
; 0000 009B unsigned char Speed1[]={MD23_ADD_BASE_W,Reg_Speed1, 128};		// Arrt moteur 1 dans le mode 0
; 0000 009C unsigned char Speed2[]={MD23_ADD_BASE_W,Reg_Speed2_Turn, 128};  // Arrt moteur 2 dans le mode 0
; 0000 009D unsigned char Time_OUT_Desable[]={MD23_ADD_BASE_W,Reg_Commande, Desactive_Timeout_Moteurs};
; 0000 009E 
; 0000 009F // 33) Lecture des registres
; 0000 00A0 unsigned char Read_Reg_MD23_W[]= {MD23_ADD_BASE_W,0};		    // Premire trame  envoyer:
; 0000 00A1 															    // { SLA_W=0xB0, N registre o commence la lecture }
; 0000 00A2 // =============================================================================================================================
; 0000 00A3 
; 0000 00A4 // =============================================================================================================================
; 0000 00A5 // Variables diverses
; 0000 00A6 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00A7 // Type 			Nom 				       			   				Description
; 0000 00A8 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00A9 // 1) Gestion de la carte MD23
; 0000 00AA // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00AB // Variables utilises dans la gestion de l'affichage:  limitent son rafrachissement
; 0000 00AC int Num_Reg_MD23_1=0, Num_Reg_MD23=0;                        		        // Numro du registre slectionn pour l'affichage
; 0000 00AD unsigned char Vitesse_MD23 = 0,Vitesse_MD23_1 = 1, BP_I2C=0, BP_I2C_1 = 1,  Finesse=5, Finesse_1=1;
; 0000 00AE unsigned char SpeedMot1=128, SpeedMot1_1=128, SpeedMot2=128, SpeedMot2_1=128; // Limite le rafrachissement de l'affichage
; 0000 00AF unsigned char Choix_Mode_1=1, Choix_Mode=0;
; 0000 00B0 unsigned char Ubatt_1=0, Ubatt=0;									        // Tension alimentation carte MD23
; 0000 00B1 unsigned char Version_1=0, Version=0;
; 0000 00B2 // Reoit le contenu des registres de la carte MD23. Liste ci-dessous
; 0000 00B3 // Speed1, Speed2_Turn, Enc1a, Enc1b, Enc1c, Enc1d, Enc2a, Enc2b, Enc2c, Enc2d, Ubatt, IMot1, IMot2, SoftRev, AccRate, Mode, Cde
; 0000 00B4 unsigned char Table_Registers_MD23[]={MD23_ADD_BASE_R,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
; 0000 00B5 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00B6 // 2) Gestion du LCD BATRON
; 0000 00B7 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00B8 char Buffer_for_LCD_Line0[17], Buffer_for_LCD_Line1[17];       // Reoivent les deux lignes de texte  envoyer  l'afficheur
; 0000 00B9 															    // (16 caractres max. + Nul)
; 0000 00BA // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00BB // *****************************************************************************************************************************
; 0000 00BC 
; 0000 00BD // =============================================================================================================================
; 0000 00BE // ===================================================== Initialisations =======================================================
; 0000 00BF // =============================================================================================================================
; 0000 00C0 TWI_Master_Initialise(); 									    // Initialisation de l'interface TWI en mode Standby
	SBIW R28,63
	SBIW R28,45
	LDI  R24,74
	LDI  R26,LOW(34)
	LDI  R27,HIGH(34)
	LDI  R30,LOW(_0x13*2)
	LDI  R31,HIGH(_0x13*2)
	RCALL __INITLOCB
;	Frame_I2C_LED_All_Off -> Y+106
;	Frame_I2C_LED_Switching -> Y+104
;	Frame_I2C_BP_Read -> Y+102
;	Frame_I2C_Lcd_Line -> Y+83
;	Reset_MD23 -> Y+80
;	Mode0_MD23 -> Y+77
;	Speed1 -> Y+74
;	Speed2 -> Y+71
;	Time_OUT_Desable -> Y+68
;	Read_Reg_MD23_W -> Y+66
;	Num_Reg_MD23_1 -> R16,R17
;	Num_Reg_MD23 -> R18,R19
;	Vitesse_MD23 -> R21
;	Vitesse_MD23_1 -> R20
;	BP_I2C -> Y+65
;	BP_I2C_1 -> Y+64
;	Finesse -> Y+63
;	Finesse_1 -> Y+62
;	SpeedMot1 -> Y+61
;	SpeedMot1_1 -> Y+60
;	SpeedMot2 -> Y+59
;	SpeedMot2_1 -> Y+58
;	Choix_Mode_1 -> Y+57
;	Choix_Mode -> Y+56
;	Ubatt_1 -> Y+55
;	Ubatt -> Y+54
;	Version_1 -> Y+53
;	Version -> Y+52
;	Table_Registers_MD23 -> Y+34
;	Buffer_for_LCD_Line0 -> Y+17
;	Buffer_for_LCD_Line1 -> Y+0
	__GETWRN 16,17,0
	__GETWRN 18,19,0
	LDI  R21,0
	LDI  R20,1
	RCALL _TWI_Master_Initialise
; 0000 00C1 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00C2 // Global enable interrupts
; 0000 00C3 #asm("sei")							// L'autorisation des interruptions doit se faire aprs l'initialisation de l'interface TWI
	sei
; 0000 00C4 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00C5 TWI_Start_Transc_With_Data(Frame_I2C_LED_All_Off,sizeof(Frame_I2C_LED_All_Off)); // Extinction des LEDs de la carte S_ISI
	MOVW R30,R28
	SUBI R30,LOW(-(106))
	SBCI R31,HIGH(-(106))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
; 0000 00C6 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00C7 // Initialisation de l'afficheur I2C BATRON
; 0000 00C8 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00C9 Init_LCD_I2C_BATRON();
	RCALL _Init_LCD_I2C_BATRON
; 0000 00CA // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00CB // Affichage d'un message d'accueil
; 0000 00CC // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00CD sprintf(Buffer_for_LCD_Line0,Texte_Accueil_Ligne1);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R5
	ST   -Y,R4
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 00CE sprintf(Buffer_for_LCD_Line1,Texte_Accueil_Ligne2);
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R7
	ST   -Y,R6
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 00CF Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 00D0 delay_ms(4000);
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 00D1 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00D2 // Initialisation des registres de  la carte MD23
; 0000 00D3 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00D4 TWI_Start_Transc_With_Data(Reset_MD23,sizeof(Reset_MD23));
	MOVW R30,R28
	SUBI R30,LOW(-(80))
	SBCI R31,HIGH(-(80))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
; 0000 00D5 TWI_Start_Transc_With_Data(Time_OUT_Desable,sizeof(Time_OUT_Desable));
	MOVW R30,R28
	SUBI R30,LOW(-(68))
	SBCI R31,HIGH(-(68))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
; 0000 00D6 TWI_Start_Transc_With_Data(Mode0_MD23,sizeof(Mode0_MD23));
	MOVW R30,R28
	SUBI R30,LOW(-(77))
	SBCI R31,HIGH(-(77))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
; 0000 00D7 TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	MOVW R30,R28
	SUBI R30,LOW(-(74))
	SBCI R31,HIGH(-(74))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
; 0000 00D8 TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
	MOVW R30,R28
	SUBI R30,LOW(-(71))
	SBCI R31,HIGH(-(71))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
; 0000 00D9 // =============================================================================================================================
; 0000 00DA 
; 0000 00DB // =============================================================================================================================
; 0000 00DC // ================================================ Boucle principale ==========================================================
; 0000 00DD // =============================================================================================================================
; 0000 00DE while (1)
_0x14:
; 0000 00DF       {
; 0000 00E0 // ---------------------------------------------  Champ Lecture des donnes ----------------------------------------------------
; 0000 00E1 // Lecture de l'tat des boutons-poussoir (BP)
; 0000 00E2 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 00E3 // Lecture des BP pour affichage sur les LED
; 0000 00E4 	TWI_Start_Transc_With_Data(Frame_I2C_BP_Read,1);    // Envoi de l'octet d'adresse des BP: SLA+R=0x43
	MOVW R30,R28
	SUBI R30,LOW(-(102))
	SBCI R31,HIGH(-(102))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
; 0000 00E5 																		// Rcupration de l'octet reprsentatif de l'tat des BP
; 0000 00E6 	TWI_Get_Data_From_Transceiver(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read));
	MOVW R30,R28
	SUBI R30,LOW(-(102))
	SBCI R31,HIGH(-(102))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Get_Data_From_Transceiver
; 0000 00E7 // Lecture des BP avec gestion anti-rebond pour parcourir les menus
; 0000 00E8     BP_I2C = Lire_BP_I2C();
	RCALL _Lire_BP_I2C
	__PUTB1SX 65
; 0000 00E9 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 00EA // Lecture des registres de la carte MD23
; 0000 00EB    if (Menu != Reglage_Valeurs_Mode0_MD23)
	LDS  R26,_Menu
	LDS  R27,_Menu+1
	SBIW R26,7
	BREQ _0x17
; 0000 00EC    {                                                           // Envoi de l'octet d'adresse MD23 + bit RW=criture + n du Reg
; 0000 00ED 	TWI_Start_Transc_With_Data(Read_Reg_MD23_W,sizeof(Read_Reg_MD23_W));
	MOVW R30,R28
	SUBI R30,LOW(-(66))
	SBCI R31,HIGH(-(66))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
; 0000 00EE    	TWI_Start_Transc_With_Data(Table_Registers_MD23,18);  		// Envoi octet d'adresse MD23 +  bit RW=lecture
	MOVW R30,R28
	ADIW R30,34
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
; 0000 00EF 	TWI_Get_Data_From_Transceiver(Table_Registers_MD23,sizeof(Table_Registers_MD23));
	MOVW R30,R28
	ADIW R30,34
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	RCALL _TWI_Get_Data_From_Transceiver
; 0000 00F0    }
; 0000 00F1 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 00F2 // --------------------------------------------------- Champ Traitement--------------------------------------------------------
; 0000 00F3     switch(Menu)
_0x17:
	LDS  R30,_Menu
	LDS  R31,_Menu+1
; 0000 00F4     {// Dbut du switch1
; 0000 00F5 // -------------------------------------------------Dbut Menus droulants-----------------------------------------------------
; 0000 00F6 // Menus Niveau 1 -------------------------------------------------------------------------------------------------------------
; 0000 00F7 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 00F8 // Menu 1 : Choix du test1: "Recopie de l'tat des BP sur les LED"
; 0000 00F9        case Menu1_LED_BP : if (Menu_1 != Menu)
	SBIW R30,0
	BREQ PC+2
	RJMP _0x1B
	LDS  R26,_Menu_1
	LDS  R27,_Menu_1+1
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x1C
; 0000 00FA        		{
; 0000 00FB                 sprintf(Buffer_for_LCD_Line0,TexteMenuLedBp);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R9
	ST   -Y,R8
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 00FC 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 00FD 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 00FE 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 00FF        		}
; 0000 0100        		switch (BP_I2C)
_0x1C:
	__GETB1SX 65
; 0000 0101 				{
; 0000 0102 					case ENTR_I2C: Menu = Copie_BP_Sur_Led;  break;     // touche Enter
	CPI  R30,LOW(0x40)
	BRNE _0x20
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	STS  _Menu,R30
	STS  _Menu+1,R31
	RJMP _0x1F
; 0000 0103 					case FlecheH_I2C: Menu = Menu3_SD21;  break;        // touche flche haut
_0x20:
	CPI  R30,LOW(0x2)
	BRNE _0x21
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	STS  _Menu,R30
	STS  _Menu+1,R31
	RJMP _0x1F
; 0000 0104 					case FlecheB_I2C: Menu = Menu2_MD23;  break;        // touche flche bas
_0x21:
	CPI  R30,LOW(0x4)
	BRNE _0x23
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _Menu,R30
	STS  _Menu+1,R31
	RJMP _0x1F
; 0000 0105 					default: Menu = Menu1_LED_BP;
_0x23:
	LDI  R30,LOW(0)
	STS  _Menu,R30
	STS  _Menu+1,R30
; 0000 0106 				}
_0x1F:
; 0000 0107 
; 0000 0108 			Menu_1 = Menu1_LED_BP;
	LDI  R30,LOW(0)
	STS  _Menu_1,R30
	STS  _Menu_1+1,R30
; 0000 0109 
; 0000 010A        break;
	RJMP _0x1A
; 0000 010B // ----------------------------------------------------------------------------------------------------------------------------
; 0000 010C // Menu 2 : Choix du test2: "Test de la carte moteur MD23/25"
; 0000 010D        case Menu2_MD23 : if (Menu_1 != Menu)
_0x1B:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x24
	LDS  R30,_Menu
	LDS  R31,_Menu+1
	LDS  R26,_Menu_1
	LDS  R27,_Menu_1+1
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x25
; 0000 010E        		{
; 0000 010F                 sprintf(Buffer_for_LCD_Line0,TexteMenuMD23);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R11
	ST   -Y,R10
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 0110 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 0111 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 0112 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 0113        		}
; 0000 0114        		switch (BP_I2C)
_0x25:
	__GETB1SX 65
; 0000 0115 				{
; 0000 0116 					case ENTR_I2C: Menu = Menu21_Mode_MD23;  break;     // touche Enter
	CPI  R30,LOW(0x40)
	BRNE _0x29
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RJMP _0xCE
; 0000 0117 					case FlecheH_I2C: Menu = Menu1_LED_BP;  break;      // touche flche haut
_0x29:
	CPI  R30,LOW(0x2)
	BRNE _0x2A
	LDI  R30,LOW(0)
	STS  _Menu,R30
	STS  _Menu+1,R30
	RJMP _0x28
; 0000 0118 					case FlecheB_I2C: Menu = Menu3_SD21;  break;        // touche flche bas
_0x2A:
	CPI  R30,LOW(0x4)
	BRNE _0x2C
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0xCE
; 0000 0119 					default: Menu = Menu2_MD23 ;
_0x2C:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
_0xCE:
	STS  _Menu,R30
	STS  _Menu+1,R31
; 0000 011A 				}
_0x28:
; 0000 011B 
; 0000 011C 			Menu_1 = Menu2_MD23 ;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0xCF
; 0000 011D 
; 0000 011E        break;
; 0000 011F // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0120 // Menu 3 : Choix du test3: "Test de la carte SD21"
; 0000 0121        case Menu3_SD21 : if (Menu_1 != Menu)
_0x24:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x2D
	LDS  R30,_Menu
	LDS  R31,_Menu+1
	LDS  R26,_Menu_1
	LDS  R27,_Menu_1+1
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x2E
; 0000 0122        		{
; 0000 0123                 sprintf(Buffer_for_LCD_Line0,TexteMenuSD21);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R13
	ST   -Y,R12
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 0124 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 0125 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 0126 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 0127        		}
; 0000 0128        		switch (BP_I2C)
_0x2E:
	__GETB1SX 65
; 0000 0129 				{
; 0000 012A 					case ENTR_I2C: Menu = Menu3_SD21;  break;           // touche Enter
	CPI  R30,LOW(0x40)
	BREQ _0xD0
; 0000 012B 					case FlecheH_I2C: Menu = Menu2_MD23;  break;        // touche flche haut
	CPI  R30,LOW(0x2)
	BRNE _0x33
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0xD1
; 0000 012C 					case FlecheB_I2C: Menu = Menu1_LED_BP;  break;      // touche flche bas
_0x33:
	CPI  R30,LOW(0x4)
	BRNE _0x35
	LDI  R30,LOW(0)
	STS  _Menu,R30
	STS  _Menu+1,R30
	RJMP _0x31
; 0000 012D 					default: Menu = Menu3_SD21 ;
_0x35:
_0xD0:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
_0xD1:
	STS  _Menu,R30
	STS  _Menu+1,R31
; 0000 012E 				}
_0x31:
; 0000 012F 
; 0000 0130 			Menu_1 = Menu3_SD21 ;
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0xCF
; 0000 0131 
; 0000 0132        break;
; 0000 0133 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0134 // Sous menus(Niveau 2) -------------------------------------------------------------------------------------------------------
; 0000 0135 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0136 // Sous menu 21: Choix du mode de commande des moteurs de la carte MD23/25
; 0000 0137 		case Menu21_Mode_MD23 : if (Menu_1 != Menu)
_0x2D:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x36
	LDS  R30,_Menu
	LDS  R31,_Menu+1
	LDS  R26,_Menu_1
	LDS  R27,_Menu_1+1
	CP   R30,R26
	CPC  R31,R27
	BRNE PC+2
	RJMP _0x37
; 0000 0138 			{
; 0000 0139 				sprintf(Buffer_for_LCD_Line0,Ligne0MenuMode);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne0MenuMode
	LDS  R31,_Ligne0MenuMode+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 013A 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchapOk);
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchapOk
	LDS  R31,_Ligne1ChoixEchapOk+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 013B 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 013C 				LCD_I2C_BATRON_gotoxy(0,15);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	RCALL _LCD_I2C_BATRON_gotoxy
; 0000 013D 				Built_Strng_Fram_I2C_LCDBATRON(Frame_I2C_Lcd_Line, Buffer_for_LCD_Line0, strlen(Buffer_for_LCD_Line0));
	MOVW R30,R28
	SUBI R30,LOW(-(83))
	SBCI R31,HIGH(-(83))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,19
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,21
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strlen
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Built_Strng_Fram_I2C_LCDBATRON
; 0000 013E 				TWI_Start_Transc_With_Data(Frame_I2C_Lcd_Line,strlen(Frame_I2C_Lcd_Line));
	MOVW R30,R28
	SUBI R30,LOW(-(83))
	SBCI R31,HIGH(-(83))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(85))
	SBCI R31,HIGH(-(85))
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strlen
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
; 0000 013F 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 0140 			}
; 0000 0141 
; 0000 0142 			switch (BP_I2C)
_0x37:
	__GETB1SX 65
; 0000 0143 				{
; 0000 0144 					case ENTR_I2C: Menu = Choix_Mode_MD23;  break;         // touche Enter
	CPI  R30,LOW(0x40)
	BRNE _0x3B
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	RJMP _0xD2
; 0000 0145 					case FlecheH_I2C: Menu = Menu22_Infos_MD23;  break;    // touche flche haut
_0x3B:
	CPI  R30,LOW(0x2)
	BRNE _0x3C
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RJMP _0xD2
; 0000 0146 					case FlecheB_I2C: Menu = Menu22_Infos_MD23;  break;    // touche flche bas
_0x3C:
	CPI  R30,LOW(0x4)
	BRNE _0x3D
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RJMP _0xD2
; 0000 0147 					case ECHAP_I2C : Menu = Menu2_MD23; break;             // touche ECHAP
_0x3D:
	CPI  R30,LOW(0x80)
	BRNE _0x3F
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0xD2
; 0000 0148 					default: Menu = Menu21_Mode_MD23 ;
_0x3F:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
_0xD2:
	STS  _Menu,R30
	STS  _Menu+1,R31
; 0000 0149 				}
; 0000 014A 
; 0000 014B 			Menu_1 = Menu21_Mode_MD23;
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RJMP _0xCF
; 0000 014C 		break;
; 0000 014D // ----------------------------------------------------------------------------------------------------------------------------
; 0000 014E // Sous menu 22 : Choix de l'affichage du contenu des registres de la carte MD23/25
; 0000 014F 		case Menu22_Infos_MD23: if (Menu_1 != Menu)
_0x36:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x40
	LDS  R30,_Menu
	LDS  R31,_Menu+1
	LDS  R26,_Menu_1
	LDS  R27,_Menu_1+1
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x41
; 0000 0150 			{
; 0000 0151 				sprintf(Buffer_for_LCD_Line0,Ligne0MenuInfos);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne0MenuInfos
	LDS  R31,_Ligne0MenuInfos+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 0152 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 0153 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 0154 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 0155 			}
; 0000 0156 
; 0000 0157 			switch (BP_I2C)
_0x41:
	__GETB1SX 65
; 0000 0158 				{
; 0000 0159 					case ENTR_I2C: Menu = Info_All;  break;
	CPI  R30,LOW(0x40)
	BRNE _0x45
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	RJMP _0xD3
; 0000 015A 					case FlecheH_I2C: Menu = Menu21_Mode_MD23;  break;
_0x45:
	CPI  R30,LOW(0x2)
	BRNE _0x46
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RJMP _0xD3
; 0000 015B 					case FlecheB_I2C: Menu = Menu21_Mode_MD23;  break;
_0x46:
	CPI  R30,LOW(0x4)
	BRNE _0x47
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RJMP _0xD3
; 0000 015C 					case ECHAP_I2C : Menu = Menu2_MD23; break;              // touche ECHAP
_0x47:
	CPI  R30,LOW(0x80)
	BRNE _0x49
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0xD3
; 0000 015D 					default: Menu = Menu22_Infos_MD23 ;
_0x49:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
_0xD3:
	STS  _Menu,R30
	STS  _Menu+1,R31
; 0000 015E 				}
; 0000 015F 
; 0000 0160 			Menu_1 = Menu22_Infos_MD23 ;
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RJMP _0xCF
; 0000 0161 		break;
; 0000 0162 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0163 // Tests ----------------------------------------------------------------------------------------------------------------------
; 0000 0164 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0165 // Test1: Affichage du nom du BP et de la LED  laquelle il est associ sur le LCD
; 0000 0166 			case Copie_BP_Sur_Led : if ((Menu_1 != Menu) || ((BP_I2C != BP_I2C_1) && (BP_I2C != 0xFF)))
_0x40:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x4A
	LDS  R30,_Menu
	LDS  R31,_Menu+1
	LDS  R26,_Menu_1
	LDS  R27,_Menu_1+1
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x4C
	__GETB1SX 64
	__GETB2SX 65
	CP   R30,R26
	BREQ _0x4D
	CPI  R26,LOW(0xFF)
	BRNE _0x4C
_0x4D:
	RJMP _0x4B
_0x4C:
; 0000 0167 				{
; 0000 0168 				 sprintf(Buffer_for_LCD_Line0,TexteTest1BpsurLed);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_TexteTest1BpsurLed
	LDS  R31,_TexteTest1BpsurLed+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 0169 
; 0000 016A 				 switch (BP_I2C)
	__GETB1SX 65
; 0000 016B 				  {
; 0000 016C 				 	case ENTR_I2C : sprintf(Buffer_for_LCD_Line1,BpEntrSurD6); break;
	CPI  R30,LOW(0x40)
	BRNE _0x53
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpEntrSurD6
	LDS  R31,_BpEntrSurD6+1
	RJMP _0xD4
; 0000 016D 				 	case FlecheH_I2C : sprintf(Buffer_for_LCD_Line1,BpFlecheHSurD1); break;
_0x53:
	CPI  R30,LOW(0x2)
	BRNE _0x54
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpFlecheHSurD1
	LDS  R31,_BpFlecheHSurD1+1
	RJMP _0xD4
; 0000 016E 				 	case FlecheB_I2C : sprintf(Buffer_for_LCD_Line1,BpFlecheHSurD2); break;
_0x54:
	CPI  R30,LOW(0x4)
	BRNE _0x55
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpFlecheHSurD2
	LDS  R31,_BpFlecheHSurD2+1
	RJMP _0xD4
; 0000 016F 				 	case ECHAP_I2C : sprintf(Buffer_for_LCD_Line1,BpEchSurD7); break;
_0x55:
	CPI  R30,LOW(0x80)
	BRNE _0x56
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpEchSurD7
	LDS  R31,_BpEchSurD7+1
	RJMP _0xD4
; 0000 0170 				 	case OK_I2C : sprintf(Buffer_for_LCD_Line1,BpOkSurD5); break;
_0x56:
	CPI  R30,LOW(0x20)
	BRNE _0x57
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpOkSurD5
	LDS  R31,_BpOkSurD5+1
	RJMP _0xD4
; 0000 0171 				 	case MOINS_I2C: sprintf(Buffer_for_LCD_Line1,BpMoinsSurD3); break;
_0x57:
	CPI  R30,LOW(0x8)
	BRNE _0x58
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpMoinsSurD3
	LDS  R31,_BpMoinsSurD3+1
	RJMP _0xD4
; 0000 0172 				 	case PLUS_I2C: sprintf(Buffer_for_LCD_Line1,BpPlusSurD0); break;
_0x58:
	CPI  R30,LOW(0x1)
	BRNE _0x59
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpPlusSurD0
	LDS  R31,_BpPlusSurD0+1
	RJMP _0xD4
; 0000 0173 				 	case SET_I2C: sprintf(Buffer_for_LCD_Line1,BpSetSurD4); break;
_0x59:
	CPI  R30,LOW(0x10)
	BRNE _0x5A
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpSetSurD4
	LDS  R31,_BpSetSurD4+1
	RJMP _0xD4
; 0000 0174 				 	case 0 : sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchap );
_0x5A:
	CPI  R30,0
	BRNE _0x52
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchap
	LDS  R31,_Ligne1ChoixEchap+1
_0xD4:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 0175 				  }
_0x52:
; 0000 0176 
; 0000 0177 					Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 0178 					BP_I2C_1 = BP_I2C;
	__GETB1SX 65
	__PUTB1SX 64
; 0000 0179 			   	 }
; 0000 017A 
; 0000 017B         		if (BP_I2C == ECHAP_I2C)
_0x4B:
	__GETB2SX 65
	CPI  R26,LOW(0x80)
	BRNE _0x5C
; 0000 017C         		  {
; 0000 017D         			Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1];
	MOVW R30,R28
	SUBI R30,LOW(-(104))
	SBCI R31,HIGH(-(104))
	ADIW R30,1
	MOVW R26,R30
	__GETB1SX 103
	COM  R30
	ST   X,R30
; 0000 017E         			TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,2);  	// Les LED affichent l'tat des BP
	MOVW R30,R28
	SUBI R30,LOW(-(104))
	SBCI R31,HIGH(-(104))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
; 0000 017F         			delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0180         			Menu = Menu1_LED_BP;
	LDI  R30,LOW(0)
	STS  _Menu,R30
	STS  _Menu+1,R30
; 0000 0181         		  }
; 0000 0182         		else  Menu = Copie_BP_Sur_Led;
	RJMP _0x5D
_0x5C:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	STS  _Menu,R30
	STS  _Menu+1,R31
; 0000 0183 
; 0000 0184 			    Menu_1 = Copie_BP_Sur_Led;
_0x5D:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP _0xCF
; 0000 0185 			break;
; 0000 0186 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0187 // Test 2.1: Rglage du mode de commande des moteurs
; 0000 0188 	        case Choix_Mode_MD23: if ((Menu_1 != Menu) || (Choix_Mode_1 != Choix_Mode))
_0x4A:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x5E
	LDS  R30,_Menu
	LDS  R31,_Menu+1
	LDS  R26,_Menu_1
	LDS  R27,_Menu_1+1
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x60
	LDD  R30,Y+56
	LDD  R26,Y+57
	CP   R30,R26
	BREQ _0x5F
_0x60:
; 0000 0189 	          {
; 0000 018A 	        	 sprintf(Buffer_for_LCD_Line0,"Choix: Mode%-u    ",Choix_Mode);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,340
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+60
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
; 0000 018B 	        	 sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchapOk);
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchapOk
	LDS  R31,_Ligne1ChoixEchapOk+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 018C 	        	 Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 018D 	        	 Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 018E 	        	 Choix_Mode_1 = Choix_Mode;
	LDD  R30,Y+56
	STD  Y+57,R30
; 0000 018F 	          }
; 0000 0190 
; 0000 0191 	          switch (BP_I2C)
_0x5F:
	__GETB1SX 65
; 0000 0192 				{
; 0000 0193 					case ECHAP_I2C : Menu=Menu21_Mode_MD23; break;  // touche ECHAP
	CPI  R30,LOW(0x80)
	BRNE _0x65
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RJMP _0xD5
; 0000 0194 					case FlecheH_I2C: if (Choix_Mode < 3) Choix_Mode = Choix_Mode + 1; else Choix_Mode=0;  break;
_0x65:
	CPI  R30,LOW(0x2)
	BRNE _0x66
	LDD  R26,Y+56
	CPI  R26,LOW(0x3)
	BRSH _0x67
	LDD  R30,Y+56
	SUBI R30,-LOW(1)
	RJMP _0xD6
_0x67:
	LDI  R30,LOW(0)
_0xD6:
	STD  Y+56,R30
	RJMP _0x64
; 0000 0195 					case FlecheB_I2C: if (Choix_Mode > 0) Choix_Mode = Choix_Mode - 1; else Choix_Mode=3;  break;
_0x66:
	CPI  R30,LOW(0x4)
	BRNE _0x69
	LDD  R26,Y+56
	CPI  R26,LOW(0x1)
	BRLO _0x6A
	LDD  R30,Y+56
	SUBI R30,LOW(1)
	RJMP _0xD7
_0x6A:
	LDI  R30,LOW(3)
_0xD7:
	STD  Y+56,R30
	RJMP _0x64
; 0000 0196 					case ENTR_I2C: if (Choix_Mode == 0) {SpeedMot1 = 128; SpeedMot2 = 128; Menu = Reglage_Valeurs_Mode0_MD23;};	break;
_0x69:
	CPI  R30,LOW(0x40)
	BRNE _0x6E
	LDD  R30,Y+56
	CPI  R30,0
	BRNE _0x6D
	LDI  R30,LOW(128)
	STD  Y+61,R30
	STD  Y+59,R30
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	STS  _Menu,R30
	STS  _Menu+1,R31
_0x6D:
	RJMP _0x64
; 0000 0197 
; 0000 0198 					default: Menu=Choix_Mode_MD23;
_0x6E:
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
_0xD5:
	STS  _Menu,R30
	STS  _Menu+1,R31
; 0000 0199 				}
_0x64:
; 0000 019A 
; 0000 019B 			  Menu_1 = Choix_Mode_MD23;
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	RJMP _0xCF
; 0000 019C 	        break;
; 0000 019D // ----------------------------------------------------------------------------------------------------------------------------
; 0000 019E             case Reglage_Valeurs_Mode0_MD23:   if ((Menu_1 != Menu) || (SpeedMot1_1 != SpeedMot1)||(SpeedMot2_1 != SpeedMot2)||(Finesse_1 != Finesse))
_0x5E:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x6F
	LDS  R30,_Menu
	LDS  R31,_Menu+1
	LDS  R26,_Menu_1
	LDS  R27,_Menu_1+1
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x71
	LDD  R30,Y+61
	LDD  R26,Y+60
	CP   R30,R26
	BRNE _0x71
	LDD  R30,Y+59
	LDD  R26,Y+58
	CP   R30,R26
	BRNE _0x71
	LDD  R30,Y+63
	LDD  R26,Y+62
	CP   R30,R26
	BRNE _0x71
	RJMP _0x70
_0x71:
; 0000 019F               {
; 0000 01A0                 sprintf(Buffer_for_LCD_Line0,"1.%-u Mode%-u (+%-u)  ",Choix_Mode+1,Choix_Mode,Finesse);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,359
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+60
	SUBI R30,-LOW(1)
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	__GETB1SX 64
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	__GETB1SX 75
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,12
	RCALL _sprintf
	ADIW R28,16
; 0000 01A1                 sprintf(Buffer_for_LCD_Line1,"SM1=%-u SM2=%-u",SpeedMot1,SpeedMot2);
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,382
	ST   -Y,R31
	ST   -Y,R30
	__GETB1SX 65
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	__GETB1SX 67
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,8
	RCALL _sprintf
	ADIW R28,12
; 0000 01A2                 Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 01A3                 Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 01A4                 SpeedMot1_1 = SpeedMot1; SpeedMot2_1 = SpeedMot2; Finesse_1 = Finesse;
	LDD  R30,Y+61
	STD  Y+60,R30
	LDD  R30,Y+59
	STD  Y+58,R30
	LDD  R30,Y+63
	STD  Y+62,R30
; 0000 01A5               }
; 0000 01A6 
; 0000 01A7 
; 0000 01A8               switch (BP_I2C)
_0x70:
	__GETB1SX 65
; 0000 01A9 				{
; 0000 01AA 				 	case ECHAP_I2C :  Menu=Choix_Mode_MD23; break;
	CPI  R30,LOW(0x80)
	BRNE _0x76
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	RJMP _0xD8
; 0000 01AB 
; 0000 01AC 				 	case PLUS_I2C:
_0x76:
	CPI  R30,LOW(0x1)
	BRNE _0x77
; 0000 01AD 				 		switch (Choix_Moteur)
	LDI  R30,0
	SBRC R2,0
	LDI  R30,1
; 0000 01AE 				 		  {
; 0000 01AF 				 		   	case Moteur1: if (Finesse==1)
	CPI  R30,0
	BRNE _0x7B
	LDD  R26,Y+63
	CPI  R26,LOW(0x1)
	BRNE _0x7C
; 0000 01B0 				 		   					if (SpeedMot1 < 255) SpeedMot1++; else SpeedMot1=255;
	LDD  R26,Y+61
	CPI  R26,LOW(0xFF)
	BRSH _0x7D
	LDD  R30,Y+61
	SUBI R30,-LOW(1)
	RJMP _0xD9
_0x7D:
	LDI  R30,LOW(255)
_0xD9:
	STD  Y+61,R30
; 0000 01B1 				 		   			else
	RJMP _0x7F
_0x7C:
; 0000 01B2 				 		   					if (SpeedMot1 < 250) SpeedMot1+=5; else SpeedMot1=255;
	LDD  R26,Y+61
	CPI  R26,LOW(0xFA)
	BRSH _0x80
	LDD  R30,Y+61
	SUBI R30,-LOW(5)
	RJMP _0xDA
_0x80:
	LDI  R30,LOW(255)
_0xDA:
	STD  Y+61,R30
; 0000 01B3 				 		   	break;
_0x7F:
	RJMP _0x7A
; 0000 01B4 				 		   	case Moteur2: if (Finesse==1)
_0x7B:
	CPI  R30,LOW(0x1)
	BRNE _0x7A
	LDD  R26,Y+63
	CPI  R26,LOW(0x1)
	BRNE _0x83
; 0000 01B5 				 		   					if (SpeedMot2 < 255) SpeedMot2++; else SpeedMot2=255;
	LDD  R26,Y+59
	CPI  R26,LOW(0xFF)
	BRSH _0x84
	LDD  R30,Y+59
	SUBI R30,-LOW(1)
	RJMP _0xDB
_0x84:
	LDI  R30,LOW(255)
_0xDB:
	STD  Y+59,R30
; 0000 01B6 				 		   			else
	RJMP _0x86
_0x83:
; 0000 01B7 				 		   					if (SpeedMot2 < 250) SpeedMot2+=5; else SpeedMot2=255;
	LDD  R26,Y+59
	CPI  R26,LOW(0xFA)
	BRSH _0x87
	LDD  R30,Y+59
	SUBI R30,-LOW(5)
	RJMP _0xDC
_0x87:
	LDI  R30,LOW(255)
_0xDC:
	STD  Y+59,R30
; 0000 01B8 				 		   	break;
_0x86:
; 0000 01B9 				 		  }
_0x7A:
; 0000 01BA 				 	break;
	RJMP _0x75
; 0000 01BB 
; 0000 01BC 				 	case MOINS_I2C:
_0x77:
	CPI  R30,LOW(0x8)
	BRNE _0x89
; 0000 01BD 				 	    switch (Choix_Moteur)
	LDI  R30,0
	SBRC R2,0
	LDI  R30,1
; 0000 01BE 				 		  {
; 0000 01BF 				 		   	case Moteur1: if (Finesse==1)
	CPI  R30,0
	BRNE _0x8D
	LDD  R26,Y+63
	CPI  R26,LOW(0x1)
	BRNE _0x8E
; 0000 01C0 				 		   					if (SpeedMot1 > 0) SpeedMot1--; else SpeedMot1=0;
	LDD  R26,Y+61
	CPI  R26,LOW(0x1)
	BRLO _0x8F
	LDD  R30,Y+61
	SUBI R30,LOW(1)
	RJMP _0xDD
_0x8F:
	LDI  R30,LOW(0)
_0xDD:
	STD  Y+61,R30
; 0000 01C1 				 		   			else
	RJMP _0x91
_0x8E:
; 0000 01C2 				 		   					if (SpeedMot1 > 5) SpeedMot1-=5; else SpeedMot1=0;
	LDD  R26,Y+61
	CPI  R26,LOW(0x6)
	BRLO _0x92
	LDD  R30,Y+61
	SUBI R30,LOW(5)
	RJMP _0xDE
_0x92:
	LDI  R30,LOW(0)
_0xDE:
	STD  Y+61,R30
; 0000 01C3 				 		   	break;
_0x91:
	RJMP _0x8C
; 0000 01C4 				 		   	case Moteur2: if (Finesse==1)
_0x8D:
	CPI  R30,LOW(0x1)
	BRNE _0x8C
	LDD  R26,Y+63
	CPI  R26,LOW(0x1)
	BRNE _0x95
; 0000 01C5 				 		   					if (SpeedMot2 > 0) SpeedMot2--; else SpeedMot2=0;
	LDD  R26,Y+59
	CPI  R26,LOW(0x1)
	BRLO _0x96
	LDD  R30,Y+59
	SUBI R30,LOW(1)
	RJMP _0xDF
_0x96:
	LDI  R30,LOW(0)
_0xDF:
	STD  Y+59,R30
; 0000 01C6 				 		   			else
	RJMP _0x98
_0x95:
; 0000 01C7 				 		   					if (SpeedMot2 > 5) SpeedMot2-=5; else SpeedMot2=0;
	LDD  R26,Y+59
	CPI  R26,LOW(0x6)
	BRLO _0x99
	LDD  R30,Y+59
	SUBI R30,LOW(5)
	RJMP _0xE0
_0x99:
	LDI  R30,LOW(0)
_0xE0:
	STD  Y+59,R30
; 0000 01C8 				 			break;
_0x98:
; 0000 01C9 				 		  }
_0x8C:
; 0000 01CA 				 	break;
	RJMP _0x75
; 0000 01CB 
; 0000 01CC 				 	case FlecheH_I2C: if (Finesse==1) Finesse = 5; else Finesse = 1; break;
_0x89:
	CPI  R30,LOW(0x2)
	BRNE _0x9B
	LDD  R26,Y+63
	CPI  R26,LOW(0x1)
	BRNE _0x9C
	LDI  R30,LOW(5)
	RJMP _0xE1
_0x9C:
	LDI  R30,LOW(1)
_0xE1:
	STD  Y+63,R30
	RJMP _0x75
; 0000 01CD 
; 0000 01CE 				 	case FlecheB_I2C: if (Finesse==1) Finesse = 5; else Finesse = 1; break;
_0x9B:
	CPI  R30,LOW(0x4)
	BRNE _0x9E
	LDD  R26,Y+63
	CPI  R26,LOW(0x1)
	BRNE _0x9F
	LDI  R30,LOW(5)
	RJMP _0xE2
_0x9F:
	LDI  R30,LOW(1)
_0xE2:
	STD  Y+63,R30
	RJMP _0x75
; 0000 01CF 
; 0000 01D0 				 	case OK_I2C: if (Choix_Moteur == 1) Choix_Moteur=0; else Choix_Moteur=1; break;
_0x9E:
	CPI  R30,LOW(0x20)
	BRNE _0xA1
	SBRS R2,0
	RJMP _0xA2
	CLT
	RJMP _0xE3
_0xA2:
	SET
_0xE3:
	BLD  R2,0
	RJMP _0x75
; 0000 01D1 
; 0000 01D2 				 	case SET_I2C:   Speed1[2] = SpeedMot1; Speed2[2] = SpeedMot2;
_0xA1:
	CPI  R30,LOW(0x10)
	BRNE _0xA5
	MOVW R30,R28
	SUBI R30,LOW(-(74))
	SBCI R31,HIGH(-(74))
	ADIW R30,2
	LDD  R26,Y+61
	STD  Z+0,R26
	MOVW R30,R28
	SUBI R30,LOW(-(71))
	SBCI R31,HIGH(-(71))
	ADIW R30,2
	LDD  R26,Y+59
	STD  Z+0,R26
; 0000 01D3 				 				    TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	MOVW R30,R28
	SUBI R30,LOW(-(74))
	SBCI R31,HIGH(-(74))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
; 0000 01D4 									TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
	MOVW R30,R28
	SUBI R30,LOW(-(71))
	SBCI R31,HIGH(-(71))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
; 0000 01D5 				    break;
	RJMP _0x75
; 0000 01D6 
; 0000 01D7 					default: Menu = Reglage_Valeurs_Mode0_MD23;
_0xA5:
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
_0xD8:
	STS  _Menu,R30
	STS  _Menu+1,R31
; 0000 01D8 				}
_0x75:
; 0000 01D9 			  Menu_1 = Reglage_Valeurs_Mode0_MD23;
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	RJMP _0xCF
; 0000 01DA 			break;
; 0000 01DB // ----------------------------------------------------------------------------------------------------------------------------
; 0000 01DC // Test 2.2.1: Affichage du contenu des registres de la carte MD23/MD25
; 0000 01DD 		case Info_All: Vitesse_MD23 = Table_Registers_MD23[6];
_0x6F:
	CPI  R30,LOW(0xE)
	LDI  R26,HIGH(0xE)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xA6
	LDD  R21,Y+40
; 0000 01DE 			if ((Menu_1 != Menu)||(Num_Reg_MD23_1 != Num_Reg_MD23)||(Vitesse_MD23_1 != Vitesse_MD23))
	LDS  R30,_Menu
	LDS  R31,_Menu+1
	LDS  R26,_Menu_1
	LDS  R27,_Menu_1+1
	CP   R30,R26
	CPC  R31,R27
	BRNE _0xA8
	__CPWRR 18,19,16,17
	BRNE _0xA8
	CP   R21,R20
	BREQ _0xA7
_0xA8:
; 0000 01DF 			  {
; 0000 01E0 				sprintf(Buffer_for_LCD_Line0,"2.2.1 Reg%-u= %-u",Num_Reg_MD23,Table_Registers_MD23[Num_Reg_MD23+1]) ;
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,398
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R18
	RCALL __CWD1
	RCALL __PUTPARD1
	MOVW R30,R18
	ADIW R30,1
	MOVW R26,R28
	ADIW R26,42
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,8
	RCALL _sprintf
	ADIW R28,12
; 0000 01E1 				strcpyf(Buffer_for_LCD_Line1,Ligne1PlusMoins);
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1PlusMoins
	LDS  R31,_Ligne1PlusMoins+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strcpyf
; 0000 01E2 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 01E3 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 01E4 				Num_Reg_MD23_1 = Num_Reg_MD23; Vitesse_MD23_1 = Vitesse_MD23;
	MOVW R16,R18
	MOV  R20,R21
; 0000 01E5 			  }
; 0000 01E6 
; 0000 01E7 			switch (BP_I2C)
_0xA7:
	__GETB1SX 65
; 0000 01E8 				{
; 0000 01E9 					case ECHAP_I2C : Menu=Menu22_Infos_MD23; break;
	CPI  R30,LOW(0x80)
	BRNE _0xAD
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RJMP _0xE4
; 0000 01EA 					case PLUS_I2C: if (Num_Reg_MD23<16) Num_Reg_MD23++; else Num_Reg_MD23=0;  break;
_0xAD:
	CPI  R30,LOW(0x1)
	BRNE _0xAE
	__CPWRN 18,19,16
	BRGE _0xAF
	__ADDWRN 18,19,1
	RJMP _0xB0
_0xAF:
	__GETWRN 18,19,0
_0xB0:
	RJMP _0xAC
; 0000 01EB 					case MOINS_I2C: if (Num_Reg_MD23>0) Num_Reg_MD23--; else Num_Reg_MD23=16;  break;
_0xAE:
	CPI  R30,LOW(0x8)
	BRNE _0xB1
	CLR  R0
	CP   R0,R18
	CPC  R0,R19
	BRGE _0xB2
	__SUBWRN 18,19,1
	RJMP _0xB3
_0xB2:
	__GETWRN 18,19,16
_0xB3:
	RJMP _0xAC
; 0000 01EC 					case FlecheH_I2C: Menu = Info_TensionBatt;  break;
_0xB1:
	CPI  R30,LOW(0x2)
	BRNE _0xB4
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	RJMP _0xE4
; 0000 01ED 					case FlecheB_I2C: Menu = Info_Version;  break;
_0xB4:
	CPI  R30,LOW(0x4)
	BRNE _0xB6
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
	RJMP _0xE4
; 0000 01EE 					default: Menu=Info_All;
_0xB6:
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
_0xE4:
	STS  _Menu,R30
	STS  _Menu+1,R31
; 0000 01EF 				}
_0xAC:
; 0000 01F0 
; 0000 01F1 			Menu_1 = Info_All;
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	RJMP _0xCF
; 0000 01F2 		break;
; 0000 01F3 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 01F4 // Test 2.2.2: Affichage de la version du logiciel implant dans la carte MD23, MD25
; 0000 01F5 		case Info_Version:	Version = Table_Registers_MD23[14];
_0xA6:
	CPI  R30,LOW(0xD)
	LDI  R26,HIGH(0xD)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xB7
	LDD  R30,Y+48
	STD  Y+52,R30
; 0000 01F6 			if ((Menu_1 != Menu)||(Version_1 != Version))
	LDS  R30,_Menu
	LDS  R31,_Menu+1
	LDS  R26,_Menu_1
	LDS  R27,_Menu_1+1
	CP   R30,R26
	CPC  R31,R27
	BRNE _0xB9
	LDD  R30,Y+52
	LDD  R26,Y+53
	CP   R30,R26
	BREQ _0xB8
_0xB9:
; 0000 01F7    			  {
; 0000 01F8 				sprintf(Buffer_for_LCD_Line0,"2.2.2 Version=%-u",Version);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,416
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+56
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
; 0000 01F9 				strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchap
	LDS  R31,_Ligne1ChoixEchap+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strcpyf
; 0000 01FA 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 01FB 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 01FC 				Version_1 = Version;
	LDD  R30,Y+52
	STD  Y+53,R30
; 0000 01FD 			  }
; 0000 01FE 
; 0000 01FF 			switch (BP_I2C)
_0xB8:
	__GETB1SX 65
; 0000 0200 				{
; 0000 0201 					case ECHAP_I2C : Menu=Menu22_Infos_MD23; break;
	CPI  R30,LOW(0x80)
	BRNE _0xBE
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RJMP _0xE5
; 0000 0202 					case FlecheH_I2C: Menu = Info_All;  break;
_0xBE:
	CPI  R30,LOW(0x2)
	BRNE _0xBF
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	RJMP _0xE5
; 0000 0203 					case FlecheB_I2C: Menu = Info_TensionBatt;  break;
_0xBF:
	CPI  R30,LOW(0x4)
	BRNE _0xC1
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	RJMP _0xE5
; 0000 0204 					default: Menu=Info_Version;
_0xC1:
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
_0xE5:
	STS  _Menu,R30
	STS  _Menu+1,R31
; 0000 0205 				}
; 0000 0206 
; 0000 0207 			Menu_1 = Info_Version;
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
	RJMP _0xCF
; 0000 0208 		break;
; 0000 0209 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 020A // Test 2.2.3: Affichage de la tension d'alimentation de la batterie
; 0000 020B 		case Info_TensionBatt:  	Ubatt = Table_Registers_MD23[11];
_0xB7:
	CPI  R30,LOW(0xC)
	LDI  R26,HIGH(0xC)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x1A
	LDD  R30,Y+45
	STD  Y+54,R30
; 0000 020C 			if ((Menu_1 != Menu)||(Ubatt_1 != Ubatt))
	LDS  R30,_Menu
	LDS  R31,_Menu+1
	LDS  R26,_Menu_1
	LDS  R27,_Menu_1+1
	CP   R30,R26
	CPC  R31,R27
	BRNE _0xC4
	LDD  R30,Y+54
	LDD  R26,Y+55
	CP   R30,R26
	BREQ _0xC3
_0xC4:
; 0000 020D    			  {
; 0000 020E 					sprintf(Buffer_for_LCD_Line0,"2.2.3 Ubatt=%-u.%-uV",Ubatt/10, Ubatt-10*(Ubatt/10));
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,434
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+58
	LDI  R30,LOW(10)
	RCALL __DIVB21U
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDD  R26,Y+62
	LDI  R30,LOW(10)
	RCALL __DIVB21U
	LDI  R26,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	LDD  R26,Y+62
	RCALL __SWAPB12
	SUB  R30,R26
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,8
	RCALL _sprintf
	ADIW R28,12
; 0000 020F 					strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchap
	LDS  R31,_Ligne1ChoixEchap+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strcpyf
; 0000 0210 					Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 0211 					Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 0212 					Ubatt_1 = Ubatt;
	LDD  R30,Y+54
	STD  Y+55,R30
; 0000 0213 			  }
; 0000 0214 
; 0000 0215 			switch (BP_I2C)
_0xC3:
	__GETB1SX 65
; 0000 0216 				{
; 0000 0217 					case ECHAP_I2C : Menu=Menu22_Infos_MD23; break;
	CPI  R30,LOW(0x80)
	BRNE _0xC9
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RJMP _0xE6
; 0000 0218 					case FlecheH_I2C: Menu = Info_Version;  break;
_0xC9:
	CPI  R30,LOW(0x2)
	BRNE _0xCA
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
	RJMP _0xE6
; 0000 0219 					case FlecheB_I2C: Menu = Info_All;  break;
_0xCA:
	CPI  R30,LOW(0x4)
	BRNE _0xCC
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	RJMP _0xE6
; 0000 021A 					default: Menu=Info_TensionBatt;
_0xCC:
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
_0xE6:
	STS  _Menu,R30
	STS  _Menu+1,R31
; 0000 021B 				}
; 0000 021C 
; 0000 021D 			Menu_1 = Info_TensionBatt;
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
_0xCF:
	STS  _Menu_1,R30
	STS  _Menu_1+1,R31
; 0000 021E 		break;
; 0000 021F // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0220 
; 0000 0221     }// Fin du switch1
_0x1A:
; 0000 0222 
; 0000 0223     Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1];
	MOVW R30,R28
	SUBI R30,LOW(-(104))
	SBCI R31,HIGH(-(104))
	ADIW R30,1
	MOVW R26,R30
	__GETB1SX 103
	COM  R30
	ST   X,R30
; 0000 0224 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0225 // ----------------------------------------  Champ Ecriture des rsultats  ----------------------------------------------------
; 0000 0226 // Ecriture sur les LED
; 0000 0227     TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,sizeof(Frame_I2C_LED_Switching));  	// Les LED affichent l'tat des BP
	MOVW R30,R28
	SUBI R30,LOW(-(104))
	SBCI R31,HIGH(-(104))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
; 0000 0228 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0229 //delay_ms(100);   // A utiliser pour visualiser les trames I2C
; 0000 022A   }; // Fin while(1)
	RJMP _0x14
; 0000 022B 
; 0000 022C } //Fin main
_0xCD:
	RJMP _0xCD
;
;

	.CSEG

	.DSEG

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G101:
	RCALL __SAVELOCR2
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	RCALL __GETW1P
	SBIW R30,0
	BREQ _0x2020010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	RCALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2020012
	__CPWRN 16,17,2
	BRLO _0x2020013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2020012:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL __GETW1P
	TST  R31
	BRMI _0x2020014
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
_0x2020014:
_0x2020013:
	RJMP _0x2020015
_0x2020010:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2020015:
	RCALL __LOADLOCR2
	RJMP _0x2100003
__print_G101:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2020016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x2020018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x202001C
	CPI  R18,37
	BRNE _0x202001D
	LDI  R17,LOW(1)
	RJMP _0x202001E
_0x202001D:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
_0x202001E:
	RJMP _0x202001B
_0x202001C:
	CPI  R30,LOW(0x1)
	BRNE _0x202001F
	CPI  R18,37
	BRNE _0x2020020
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RJMP _0x20200C9
_0x2020020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2020021
	LDI  R16,LOW(1)
	RJMP _0x202001B
_0x2020021:
	CPI  R18,43
	BRNE _0x2020022
	LDI  R20,LOW(43)
	RJMP _0x202001B
_0x2020022:
	CPI  R18,32
	BRNE _0x2020023
	LDI  R20,LOW(32)
	RJMP _0x202001B
_0x2020023:
	RJMP _0x2020024
_0x202001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2020025
_0x2020024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2020026
	ORI  R16,LOW(128)
	RJMP _0x202001B
_0x2020026:
	RJMP _0x2020027
_0x2020025:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x202001B
_0x2020027:
	CPI  R18,48
	BRLO _0x202002A
	CPI  R18,58
	BRLO _0x202002B
_0x202002A:
	RJMP _0x2020029
_0x202002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x202001B
_0x2020029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x202002F
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Z+4
	ST   -Y,R26
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RJMP _0x2020030
_0x202002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2020032
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	RCALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strlen
	MOV  R17,R30
	RJMP _0x2020033
_0x2020032:
	CPI  R30,LOW(0x70)
	BRNE _0x2020035
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	RCALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2020033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2020036
_0x2020035:
	CPI  R30,LOW(0x64)
	BREQ _0x2020039
	CPI  R30,LOW(0x69)
	BRNE _0x202003A
_0x2020039:
	ORI  R16,LOW(4)
	RJMP _0x202003B
_0x202003A:
	CPI  R30,LOW(0x75)
	BRNE _0x202003C
_0x202003B:
	LDI  R30,LOW(_tbl10_G101*2)
	LDI  R31,HIGH(_tbl10_G101*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x202003D
_0x202003C:
	CPI  R30,LOW(0x58)
	BRNE _0x202003F
	ORI  R16,LOW(8)
	RJMP _0x2020040
_0x202003F:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x2020071
_0x2020040:
	LDI  R30,LOW(_tbl16_G101*2)
	LDI  R31,HIGH(_tbl16_G101*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x202003D:
	SBRS R16,2
	RJMP _0x2020042
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2020043
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2020043:
	CPI  R20,0
	BREQ _0x2020044
	SUBI R17,-LOW(1)
	RJMP _0x2020045
_0x2020044:
	ANDI R16,LOW(251)
_0x2020045:
	RJMP _0x2020046
_0x2020042:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x2020046:
_0x2020036:
	SBRC R16,0
	RJMP _0x2020047
_0x2020048:
	CP   R17,R21
	BRSH _0x202004A
	SBRS R16,7
	RJMP _0x202004B
	SBRS R16,2
	RJMP _0x202004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x202004D
_0x202004C:
	LDI  R18,LOW(48)
_0x202004D:
	RJMP _0x202004E
_0x202004B:
	LDI  R18,LOW(32)
_0x202004E:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	SUBI R21,LOW(1)
	RJMP _0x2020048
_0x202004A:
_0x2020047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x202004F
_0x2020050:
	CPI  R19,0
	BREQ _0x2020052
	SBRS R16,3
	RJMP _0x2020053
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x2020054
_0x2020053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2020054:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	CPI  R21,0
	BREQ _0x2020055
	SUBI R21,LOW(1)
_0x2020055:
	SUBI R19,LOW(1)
	RJMP _0x2020050
_0x2020052:
	RJMP _0x2020056
_0x202004F:
_0x2020058:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x202005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x202005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x202005A
_0x202005C:
	CPI  R18,58
	BRLO _0x202005D
	SBRS R16,3
	RJMP _0x202005E
	SUBI R18,-LOW(7)
	RJMP _0x202005F
_0x202005E:
	SUBI R18,-LOW(39)
_0x202005F:
_0x202005D:
	SBRC R16,4
	RJMP _0x2020061
	CPI  R18,49
	BRSH _0x2020063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2020062
_0x2020063:
	RJMP _0x20200CA
_0x2020062:
	CP   R21,R19
	BRLO _0x2020067
	SBRS R16,0
	RJMP _0x2020068
_0x2020067:
	RJMP _0x2020066
_0x2020068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2020069
	LDI  R18,LOW(48)
_0x20200CA:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x202006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	CPI  R21,0
	BREQ _0x202006B
	SUBI R21,LOW(1)
_0x202006B:
_0x202006A:
_0x2020069:
_0x2020061:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	CPI  R21,0
	BREQ _0x202006C
	SUBI R21,LOW(1)
_0x202006C:
_0x2020066:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2020059
	RJMP _0x2020058
_0x2020059:
_0x2020056:
	SBRS R16,0
	RJMP _0x202006D
_0x202006E:
	CPI  R21,0
	BREQ _0x2020070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RJMP _0x202006E
_0x2020070:
_0x202006D:
_0x2020071:
_0x2020030:
_0x20200C9:
	LDI  R17,LOW(0)
_0x202001B:
	RJMP _0x2020016
_0x2020018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	RCALL __GETW1P
	RCALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	RCALL __SAVELOCR4
	MOVW R26,R28
	ADIW R26,12
	RCALL __ADDW2R15
	RCALL __GETW1P
	SBIW R30,0
	BRNE _0x2020072
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x2100004
_0x2020072:
	MOVW R26,R28
	ADIW R26,6
	RCALL __ADDW2R15
	MOVW R16,R26
	MOVW R26,R28
	ADIW R26,12
	RCALL __ADDW2R15
	RCALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	RCALL __ADDW2R15
	RCALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G101)
	LDI  R31,HIGH(_put_buff_G101)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G101
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x2100004:
	RCALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET

	.CSEG

	.CSEG
_strcpyf:
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcpyf0:
	lpm  r0,z+
    st   x+,r0
    tst  r0
    brne strcpyf0
    movw r30,r24
    ret
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
_TWI_Master_Initialise:
	LDI  R30,LOW(32)
	OUT  0x0,R30
	LDI  R30,LOW(255)
	OUT  0x3,R30
	LDI  R30,LOW(4)
	OUT  0x36,R30
	RET
_TWI_Transceiver_Busy:
	IN   R30,0x36
	ANDI R30,LOW(0x1)
	RET
_TWI_Start_Transc_With_Data:
	ST   -Y,R17
_0x2080007:
	RCALL _TWI_Transceiver_Busy
	CPI  R30,0
	BRNE _0x2080007
	LDD  R30,Y+1
	STS  _TWI_msgSize_G104,R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X
	STS  _TWI_buf_G104,R30
	ANDI R30,LOW(0x1)
	BRNE _0x208000A
	LDI  R17,LOW(1)
_0x208000C:
	LDD  R30,Y+1
	CP   R17,R30
	BRSH _0x208000D
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_TWI_buf_G104)
	SBCI R31,HIGH(-_TWI_buf_G104)
	MOVW R0,R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	MOVW R26,R0
	ST   X,R30
	SUBI R17,-1
	RJMP _0x208000C
_0x208000D:
_0x208000A:
	LDI  R30,LOW(0)
	STS  _TWI_statusReg,R30
	LDI  R30,LOW(248)
	STS  _TWI_state_G104,R30
	LDI  R30,LOW(165)
	OUT  0x36,R30
	LDD  R17,Y+0
	RJMP _0x2100002
_TWI_Get_Data_From_Transceiver:
	ST   -Y,R17
_0x2080011:
	RCALL _TWI_Transceiver_Busy
	CPI  R30,0
	BRNE _0x2080011
	LDS  R30,_TWI_statusReg
	ANDI R30,LOW(0x1)
	BREQ _0x2080014
	LDI  R17,LOW(0)
_0x2080016:
	LDD  R30,Y+1
	CP   R17,R30
	BRSH _0x2080017
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_TWI_buf_G104)
	SBCI R31,HIGH(-_TWI_buf_G104)
	LD   R30,Z
	ST   X,R30
	SUBI R17,-1
	RJMP _0x2080016
_0x2080017:
_0x2080014:
	LDS  R30,_TWI_statusReg
	ANDI R30,LOW(0x1)
	LDD  R17,Y+0
	RJMP _0x2100002
_twi_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	IN   R30,0x1
	CPI  R30,LOW(0x8)
	BREQ _0x208001C
	CPI  R30,LOW(0x10)
	BRNE _0x208001D
_0x208001C:
	LDI  R30,LOW(0)
	STS  _TWI_bufPtr_S1040006000,R30
	RJMP _0x208001E
_0x208001D:
	CPI  R30,LOW(0x18)
	BRNE _0x208001F
_0x208001E:
	RJMP _0x2080020
_0x208001F:
	CPI  R30,LOW(0x28)
	BRNE _0x2080021
_0x2080020:
	LDS  R30,_TWI_msgSize_G104
	LDS  R26,_TWI_bufPtr_S1040006000
	CP   R26,R30
	BRSH _0x2080022
	LDS  R30,_TWI_bufPtr_S1040006000
	SUBI R30,-LOW(1)
	STS  _TWI_bufPtr_S1040006000,R30
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_TWI_buf_G104)
	SBCI R31,HIGH(-_TWI_buf_G104)
	LD   R30,Z
	OUT  0x3,R30
	LDI  R30,LOW(133)
	RJMP _0x2080033
_0x2080022:
	LDS  R30,_TWI_statusReg
	ORI  R30,1
	STS  _TWI_statusReg,R30
	LDI  R30,LOW(148)
_0x2080033:
	OUT  0x36,R30
	RJMP _0x208001A
_0x2080021:
	CPI  R30,LOW(0x50)
	BRNE _0x2080024
	LDS  R30,_TWI_bufPtr_S1040006000
	SUBI R30,-LOW(1)
	STS  _TWI_bufPtr_S1040006000,R30
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_TWI_buf_G104)
	SBCI R31,HIGH(-_TWI_buf_G104)
	MOVW R26,R30
	IN   R30,0x3
	ST   X,R30
	RJMP _0x2080025
_0x2080024:
	CPI  R30,LOW(0x40)
	BRNE _0x2080026
_0x2080025:
	LDS  R30,_TWI_msgSize_G104
	SUBI R30,LOW(1)
	LDS  R26,_TWI_bufPtr_S1040006000
	CP   R26,R30
	BRSH _0x2080027
	LDI  R30,LOW(197)
	RJMP _0x2080034
_0x2080027:
	LDI  R30,LOW(133)
_0x2080034:
	OUT  0x36,R30
	RJMP _0x208001A
_0x2080026:
	CPI  R30,LOW(0x58)
	BRNE _0x2080029
	LDS  R26,_TWI_bufPtr_S1040006000
	LDI  R27,0
	SUBI R26,LOW(-_TWI_buf_G104)
	SBCI R27,HIGH(-_TWI_buf_G104)
	IN   R30,0x3
	ST   X,R30
	LDS  R30,_TWI_statusReg
	ORI  R30,1
	STS  _TWI_statusReg,R30
	LDI  R30,LOW(148)
	RJMP _0x2080035
_0x2080029:
	CPI  R30,LOW(0x38)
	BRNE _0x208002A
	LDI  R30,LOW(165)
	RJMP _0x2080035
_0x208002A:
	CPI  R30,LOW(0x20)
	BREQ _0x208002C
_0x208002C:
_0x208002D:
_0x208002E:
	IN   R30,0x1
	STS  _TWI_state_G104,R30
	LDI  R30,LOW(4)
_0x2080035:
	OUT  0x36,R30
_0x208001A:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI

	.CSEG
_Init_LCD_I2C_BATRON:
	SBIW R28,13
	LDI  R24,13
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x20A0003*2)
	LDI  R31,HIGH(_0x20A0003*2)
	RCALL __INITLOCB
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(13)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	ADIW R28,13
	RET
_LCD_I2C_BATRON_gotoxy:
	SBIW R28,3
	LDI  R30,LOW(118)
	ST   Y,R30
	LDI  R30,LOW(0)
	STD  Y+1,R30
	LDI  R30,LOW(128)
	STD  Y+2,R30
	LDD  R26,Y+4
	CPI  R26,LOW(0x10)
	BRSH _0x20A0005
	LDD  R26,Y+3
	CPI  R26,LOW(0x2)
	BRLO _0x20A0006
_0x20A0005:
	RJMP _0x20A0004
_0x20A0006:
	LDD  R30,Y+3
	CPI  R30,0
	BRNE _0x20A000A
	LDD  R30,Y+4
	SUBI R30,-LOW(128)
	RJMP _0x20A0017
_0x20A000A:
	CPI  R30,LOW(0x1)
	BRNE _0x20A0009
	LDD  R30,Y+4
	SUBI R30,-LOW(192)
_0x20A0017:
	STD  Y+2,R30
_0x20A0009:
_0x20A0004:
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
_0x2100003:
	ADIW R28,5
	RET
_Built_Strng_Fram_I2C_LCDBATRON:
	RCALL __SAVELOCR6
	__GETWRS 18,19,8
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,2
	MOVW R20,R30
	__GETWRN 16,17,0
_0x20A000D:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CP   R16,R30
	CPC  R17,R31
	BRGE _0x20A000E
	MOVW R26,R18
	LD   R26,X
	CPI  R26,LOW(0x5B)
	BRNE _0x20A000F
	MOVW R26,R20
	LDI  R30,LOW(138)
	RJMP _0x20A0018
_0x20A000F:
	MOVW R26,R18
	LD   R26,X
	CPI  R26,LOW(0x5D)
	BRNE _0x20A0011
	MOVW R26,R20
	LDI  R30,LOW(84)
	RJMP _0x20A0018
_0x20A0011:
	MOVW R26,R18
	LD   R30,X
	SUBI R30,-LOW(128)
	MOVW R26,R20
_0x20A0018:
	ST   X,R30
	__ADDWRN 18,19,1
	__ADDWRN 20,21,1
	__ADDWRN 16,17,1
	RJMP _0x20A000D
_0x20A000E:
	MOVW R26,R20
	LDI  R30,LOW(0)
	ST   X,R30
	RCALL __LOADLOCR6
	ADIW R28,12
	RET
_Displ_2Lines_On_I2C_LCDBATRON:
	SBIW R28,19
	LDI  R24,19
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x20A0013*2)
	LDI  R31,HIGH(_0x20A0013*2)
	RCALL __INITLOCB
	ST   -Y,R17
	LDI  R17,LOW(0)
_0x20A0015:
	CPI  R17,2
	BRSH _0x20A0016
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R17
	RCALL _LCD_I2C_BATRON_gotoxy
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strlen
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	SUBI R17,-1
	RJMP _0x20A0015
_0x20A0016:
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	RCALL _LCD_I2C_BATRON_gotoxy
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strlen
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Built_Strng_Fram_I2C_LCDBATRON
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strlen
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _LCD_I2C_BATRON_gotoxy
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strlen
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Built_Strng_Fram_I2C_LCDBATRON
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strlen
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	LDD  R17,Y+0
	ADIW R28,24
	RET
_Display_Arrow_0n_I2C_LCDBATRON:
	SBIW R28,6
	LDI  R30,LOW(118)
	ST   Y,R30
	LDI  R30,LOW(64)
	STD  Y+1,R30
	LDI  R30,LOW(48)
	STD  Y+2,R30
	LDI  R30,LOW(118)
	STD  Y+3,R30
	LDI  R30,LOW(64)
	STD  Y+4,R30
	LDI  R30,LOW(18)
	STD  Y+5,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _LCD_I2C_BATRON_gotoxy
	MOVW R30,R28
	ADIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _LCD_I2C_BATRON_gotoxy
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	ADIW R28,6
	RET

	.CSEG
_Lire_BP_I2C:

	.DSEG

	.CSEG
	SBIW R28,2
	LDI  R30,LOW(67)
	ST   Y,R30
	LDI  R30,LOW(0)
	STD  Y+1,R30
	RCALL __SAVELOCR2
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Get_Data_From_Transceiver
	LDD  R16,Y+3
	LDS  R30,_Etat_BP_I2C_S1060000000
	LDS  R31,_Etat_BP_I2C_S1060000000+1
	SBIW R30,0
	BRNE _0x20C0007
	CPI  R16,0
	BRNE _0x20C0008
	MOV  R17,R16
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Get_Data_From_Transceiver
	LDD  R16,Y+3
	CP   R16,R17
	BRNE _0x20C0009
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _Etat_BP_I2C_S1060000000,R30
	STS  _Etat_BP_I2C_S1060000000+1,R31
	LDI  R30,LOW(0)
	RJMP _0x2100001
_0x20C0009:
	LDI  R30,LOW(255)
	RJMP _0x2100001
_0x20C0008:
	LDI  R30,LOW(255)
	RJMP _0x2100001
_0x20C0007:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x20C0006
	CPI  R16,0
	BREQ _0x20C000D
	MOV  R17,R16
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Get_Data_From_Transceiver
	LDD  R16,Y+3
	CP   R16,R17
	BRNE _0x20C000E
	LDI  R30,LOW(0)
	STS  _Etat_BP_I2C_S1060000000,R30
	STS  _Etat_BP_I2C_S1060000000+1,R30
	MOV  R30,R16
	RJMP _0x2100001
_0x20C000E:
	LDI  R30,LOW(0)
	RJMP _0x2100001
_0x20C000D:
	LDI  R30,LOW(0)
_0x20C0006:
_0x2100001:
	RCALL __LOADLOCR2
_0x2100002:
	ADIW R28,4
	RET

	.CSEG

	.DSEG
_Ligne0MenuMode:
	.BYTE 0x2
_Ligne0MenuInfos:
	.BYTE 0x2
_TexteTest1BpsurLed:
	.BYTE 0x2
_Ligne1PlusMoins:
	.BYTE 0x2
_Ligne1ChoixEntr:
	.BYTE 0x2
_Ligne1ChoixEchap:
	.BYTE 0x2
_Ligne1ChoixEchapOk:
	.BYTE 0x2
_BpPlusSurD0:
	.BYTE 0x2
_BpFlecheHSurD1:
	.BYTE 0x2
_BpFlecheHSurD2:
	.BYTE 0x2
_BpMoinsSurD3:
	.BYTE 0x2
_BpSetSurD4:
	.BYTE 0x2
_BpOkSurD5:
	.BYTE 0x2
_BpEntrSurD6:
	.BYTE 0x2
_BpEchSurD7:
	.BYTE 0x2
_Menu:
	.BYTE 0x2
_Menu_1:
	.BYTE 0x2
__seed_G100:
	.BYTE 0x4
_TWI_msgSize_G104:
	.BYTE 0x1
_TWI_buf_G104:
	.BYTE 0x14
_TWI_state_G104:
	.BYTE 0x1
_TWI_statusReg:
	.BYTE 0x1
_TWI_bufPtr_S1040006000:
	.BYTE 0x1
_Etat_BP_I2C_S1060000000:
	.BYTE 0x2

	.CSEG

	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
